org.scalatest

# Assertions

#### trait Assertions extends AnyRef

Trait that contains ScalaTest's basic assertion methods.

You can use the assertions provided by this trait in any ScalaTest `Suite`, because `Suite` mixes in this trait. This trait is designed to be used independently of anything else in ScalaTest, though, so you can mix it into anything. (You can alternatively import the methods defined in this trait. For details, see the documentation for the `Assertions` companion object.

In any Scala program, you can write assertions by invoking `assert` and passing in a `Boolean` expression, such as:

    val left = 2
    val right = 1
    assert(left == right)

If the passed expression is `true`, `assert` will return normally. If `false`, `assert` will complete abruptly with an `AssertionError`. This behavior is provided by the `assert` method defined in object `Predef`, whose members are implicitly imported into every Scala source file. This `Assertions` traits defines another `assert` method that hides the one in `Predef`. It behaves the same, except that if `false` is passed it throws `TestFailedException` instead of `AssertionError`. The reason it throws `TestFailedException` is because `TestFailedException` carries information about exactly which item in the stack trace represents the line of test code that failed, which can help users more quickly find an offending line of code in a failing test.

If you pass the previous `Boolean` expression, `left == right` to `assert` in a ScalaTest test, a failure will be reported, but without reporting the left and right values. You can alternatively encode these values in a `String` passed as a second argument to `assert`, like this:

    val left = 2
    val right = 1
    assert(left == right, left + " did not equal " + right)

Using this form of `assert`, the failure report will include the left and right values, thereby helping you debug the problem. However, ScalaTest provides the `===` operator to make this easier. You use it like this:

    val left = 2
    val right = 1
    assert(left === right)

Because you use `===` here instead of `==`, the failure report will include the left and right values. For example, the detail message in the thrown `TestFailedException` from the `assert` shown previously will include, "2 did not equal 1". From this message you will know that the operand on the left had the value 2, and the operand on the right had the value 1.

If you're familiar with JUnit, you would use `===` in a ScalaTest `Suite` where you'd use `assertEquals` in a JUnit `TestCase`. The `===` operator is made possible by an implicit conversion from `Any` to `Equalizer`. If you're curious to understand the mechanics, see the documentation for `Equalizer` and the `convertToEqualizer` method.

#### Expected results

Although `===` provides a natural, readable extension to Scala's `assert` mechanism, as the operands become lengthy, the code becomes less readable. In addition, the `===` comparison doesn't distinguish between actual and expected values. The operands are just called `left` and `right`, because if one were named `expected` and the other `actual`, it would be difficult for people to remember which was which. To help with these limitations of assertions, `Suite` includes a method called `expect` that can be used as an alternative to `assert` with `===`. To use `expect`, you place the expected value in parentheses after `expect`, followed by curly braces containing code that should result in the expected value. For example:

    val a = 5
    val b = 2
    expect(2) {
      a - b
    }

In this case, the expected value is `2`, and the code being tested is `a - b`. This expectation will fail, and the detail message in the `TestFailedException` will read, "Expected 2, but got 3."

#### Intercepted exceptions

Sometimes you need to test whether a method throws an expected exception under certain circumstances, such as when invalid arguments are passed to the method. You can do this in the JUnit 3 style, like this:

    val s = "hi"
    try {
      s.charAt(-1)
      fail()
    }
    catch {
      case _: IndexOutOfBoundsException => // Expected, so continue
    }

If `charAt` throws `IndexOutOfBoundsException` as expected, control will transfer to the catch case, which does nothing. If, however, `charAt` fails to throw an exception, the next statement, `fail()`, will be run. The `fail` method always completes abruptly with a `TestFailedException`, thereby signaling a failed test.

To make this common use case easier to express and read, ScalaTest provides an `intercept` method. You use it like this:

    val s = "hi"
    intercept[IndexOutOfBoundsException] {
      s.charAt(-1)
    }

This code behaves much like the previous example. If `charAt` throws an instance of `IndexOutOfBoundsException`, `intercept` will return that exception. But if `charAt` completes normally, or throws a different exception, `intercept` will complete abruptly with a `TestFailedException`. `intercept` returns the caught exception so that you can inspect it further if you wish, for example, to ensure that data contained inside the exception has the expected values.

#### Getting a clue

If you want more information that is provided by default by the methods if this trait, you can supply a "clue" string in one of several ways. The extra information (or "clues") you provide will be included in the detail message of the thrown exception. Both `assert` and `expect` provide a way for a clue to be included directly, `intercept` does not. Here's an example of clues provided directly in `assert`:

    assert(1 + 1 === 3, "this is a clue")

and in `expect`:

    expect(3, "this is a clue") { 1 + 1 }

The exceptions thrown by the previous two statements will include the clue string, `"this is a clue"`, in the exception's detail message. To get the same clue in the detail message of an exception thrown by a failed `intercept` call requires using `withClue`:

    withClue("this is a clue") {
      intercept[IndexOutOfBoundsException] {
        "hi".charAt(-1)
      }
    }

The `withClue` method will only prepend the clue string to the detail message of exception types that mix in the `ModifiableMessage` trait. See the documentation for `ModifiableMessage` for more information.

Linear Supertypes
AnyRef, Any
Known Subclasses
Assertions, AssertionsForJUnit, AssertionsForJUnit, FeatureSpec, FixtureFeatureSpec, FixtureFlatSpec, FixtureFreeSpec, FixtureFunSuite, FixturePropSpec, FixtureSpec, FixtureSuite, FixtureWordSpec, FlatSpec, FreeSpec, FunSuite, JUnit3Suite, JUnitSuite, JUnitWrapperSuite, Matchers, MultipleFixtureFeatureSpec, MultipleFixtureFlatSpec, MultipleFixtureFreeSpec, MultipleFixtureFunSuite, MultipleFixturePropSpec, MultipleFixtureSpec, MultipleFixtureWordSpec, MustMatchers, MustMatchers, MustMatchersForJUnit, MustMatchersForJUnit, PropSpec, ShouldMatchers, ShouldMatchers, ShouldMatchersForJUnit, ShouldMatchersForJUnit, Spec, Specs, Suite, Suites, SuperSuite, TestNGSuite, TestNGWrapperSuite, WordSpec
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Assertions
2. AnyRef
3. Any

Visibility

1. Public
2. All

### Type Members

1. #### class Equalizer extends AnyRef

   Class used via an implicit conversion to enable any two objects to be compared with `===` in assertions in tests.

### Value Members

1. #### def != (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

2. #### def != (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

3. #### def ## (): Int

   Attributes
     final
   Definition Classes
     AnyRef → Any

4. #### def == (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

5. #### def == (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

6. #### def asInstanceOf [T0] : T0

   Attributes
     final
   Definition Classes
     Any

7. #### def assert (o: Option[String]): Unit

   Assert that an `Option[String]` is `None`.

   Assert that an `Option[String]` is `None`. If the condition is `None`, this method returns normally. Else, it throws `TestFailedException` with the `String` value of the `Some` included in the `TestFailedException`'s detail message.

   This form of `assert` is usually called in conjunction with an implicit conversion to `Equalizer`, using a `===` comparison, as in:

       assert(a === b)

   For more information on how this mechanism works, see the documentation for `Equalizer`.

   o

     the `Option[String]` to assert

8. #### def assert (o: Option[String], clue: Any): Unit

   Assert that an `Option[String]` is `None`.

   Assert that an `Option[String]` is `None`. If the condition is `None`, this method returns normally. Else, it throws `TestFailedException` with the `String` value of the `Some`, as well as the `String` obtained by invoking `toString` on the specified `message`, included in the `TestFailedException`'s detail message.

   This form of `assert` is usually called in conjunction with an implicit conversion to `Equalizer`, using a `===` comparison, as in:

       assert(a === b, "extra info reported if assertion fails")

   For more information on how this mechanism works, see the documentation for `Equalizer`.

   o

     the `Option[String]` to assert

   clue

     An objects whose `toString` method returns a message to include in a failure report.

9. #### def assert (condition: Boolean, clue: Any): Unit

   Assert that a boolean condition, described in `String` `message`, is true.

   Assert that a boolean condition, described in `String` `message`, is true. If the condition is `true`, this method returns normally. Else, it throws `TestFailedException` with the `String` obtained by invoking `toString` on the specified `message` as the exception's detail message.

   condition

     the boolean condition to assert

   clue

     An objects whose `toString` method returns a message to include in a failure report.

10. #### def assert (condition: Boolean): Unit

    Assert that a boolean condition is true.

    Assert that a boolean condition is true. If the condition is `true`, this method returns normally. Else, it throws `TestFailedException`.

    condition

      the boolean condition to assert

11. #### def clone (): AnyRef

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

12. #### implicit def convertToEqualizer (left: Any): Equalizer

    Implicit conversion from `Any` to `Equalizer`, used to enable assertions with `===` comparisons.

    Implicit conversion from `Any` to `Equalizer`, used to enable assertions with `===` comparisons.

    For more information on this mechanism, see the documentation for Equalizer.

    Because trait `Suite` mixes in `Assertions`, this implicit conversion will always be available by default in ScalaTest `Suite`s. This is the only implicit conversion that is in scope by default in every ScalaTest `Suite`. Other implicit conversions offered by ScalaTest, such as those that support the matchers DSL or `invokePrivate`, must be explicitly invited into your test code, either by mixing in a trait or importing the members of its companion object. The reason ScalaTest requires you to invite in implicit conversions (with the exception of the implicit conversion for `===` operator) is because if one of ScalaTest's implicit conversions clashes with an implicit conversion used in the code you are trying to test, your program won't compile. Thus there is a chance that if you are ever trying to use a library or test some code that also offers an implicit conversion involving a `===` operator, you could run into the problem of a compiler error due to an ambiguous implicit conversion. If that happens, you can turn off the implicit conversion offered by this `convertToEqualizer` method simply by overriding the method in your `Suite` subclass, but not marking it as implicit:

        // In your Suite subclass
        override def convertToEqualizer(left: Any) = new Equalizer(left)

    left

      the object whose type to convert to `Equalizer`.

    Attributes
      implicit

13. #### def eq (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

14. #### def equals (arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

15. #### def expect (expected: Any)(actual: Any): Unit

    Expect that the value passed as `expected` equals the value passed as `actual`.

    Expect that the value passed as `expected` equals the value passed as `actual`. If the `actual` value equals the `expected` value (as determined by `==`), `expect` returns normally. Else, `expect` throws an `TestFailedException` whose detail message includes the expected and actual values.

    expected

      the expected value

    actual

      the actual value, which should equal the passed `expected` value

16. #### def expect (expected: Any, clue: Any)(actual: Any): Unit

    Expect that the value passed as `expected` equals the value passed as `actual`.

    Expect that the value passed as `expected` equals the value passed as `actual`. If the `actual` equals the `expected` (as determined by `==`), `expect` returns normally. Else, if `actual` is not equal to `expected`, `expect` throws an `TestFailedException` whose detail message includes the expected and actual values, as well as the `String` obtained by invoking `toString` on the passed `message`.

    expected

      the expected value

    clue

      An object whose `toString` method returns a message to include in a failure report.

    actual

      the actual value, which should equal the passed `expected` value

17. #### def fail (cause: Throwable): Nothing

    Throws `TestFailedException`, with the passed `Throwable` cause, to indicate a test failed.

    Throws `TestFailedException`, with the passed `Throwable` cause, to indicate a test failed. The `getMessage` method of the thrown `TestFailedException` will return `cause.toString()`.

    cause

      a `Throwable` that indicates the cause of the failure.

18. #### def fail (message: String, cause: Throwable): Nothing

    Throws `TestFailedException`, with the passed `String` `message` as the exception's detail message and `Throwable` cause, to indicate a test failed.

    Throws `TestFailedException`, with the passed `String` `message` as the exception's detail message and `Throwable` cause, to indicate a test failed.

    message

      A message describing the failure.

    cause

      A `Throwable` that indicates the cause of the failure.

19. #### def fail (message: String): Nothing

    Throws `TestFailedException`, with the passed `String` `message` as the exception's detail message, to indicate a test failed.

    Throws `TestFailedException`, with the passed `String` `message` as the exception's detail message, to indicate a test failed.

    message

      A message describing the failure.

20. #### def fail (): Nothing

    Throws `TestFailedException` to indicate a test failed.

21. #### def finalize (): Unit

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

22. #### def getClass (): java.lang.Class[_]

    Attributes
      final
    Definition Classes
      AnyRef

23. #### def hashCode (): Int

    Definition Classes
      AnyRef → Any

24. #### def intercept [T <: AnyRef] (f: ⇒ Any)(implicit manifest: Manifest[T]): T

    Intercept and return an exception that's expected to be thrown by the passed function value.

    Intercept and return an exception that's expected to be thrown by the passed function value. The thrown exception must be an instance of the type specified by the type parameter of this method. This method invokes the passed function. If the function throws an exception that's an instance of the specified type, this method returns that exception. Else, whether the passed function returns normally or completes abruptly with a different exception, this method throws `TestFailedException`.

    Note that the type specified as this method's type parameter may represent any subtype of `AnyRef`, not just `Throwable` or one of its subclasses. In Scala, exceptions can be caught based on traits they implement, so it may at times make sense to specify a trait that the intercepted exception's class must mix in. If a class instance is passed for a type that could not possibly be used to catch an exception (such as `String`, for example), this method will complete abruptly with a `TestFailedException`.

    f

      the function value that should throw the expected exception

    manifest

      an implicit `Manifest` representing the type of the specified type parameter.

    returns

      the intercepted exception, if it is of the expected type

25. #### def isInstanceOf [T0] : Boolean

    Attributes
      final
    Definition Classes
      Any

26. #### def ne (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

27. #### def notify (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

28. #### def notifyAll (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

29. #### def synchronized [T0] (arg0: ⇒ T0): T0

    Attributes
      final
    Definition Classes
      AnyRef

30. #### def toString (): String

    Definition Classes
      AnyRef → Any

31. #### def wait (): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

32. #### def wait (arg0: Long, arg1: Int): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

33. #### def wait (arg0: Long): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

34. #### def withClue (clue: Any)(fun: ⇒ Unit): Unit

    Executes the block of code passed as the second parameter, and, if it completes abruptly with a `ModifiableMessage` exception, prepends the "clue" string passed as the first parameter to the beginning of the detail message of that thrown exception, then rethrows it.

    Executes the block of code passed as the second parameter, and, if it completes abruptly with a `ModifiableMessage` exception, prepends the "clue" string passed as the first parameter to the beginning of the detail message of that thrown exception, then rethrows it. If clue does not end in a white space character, one space will be added between it and the existing detail message (unless the detail message is not defined).

    This method allows you to add more information about what went wrong that will be reported when a test fails. Here's an example:

        withClue("(Employee's name was: " + employee.name + ")") {
          intercept[IllegalArgumentException] {
            employee.getTask(-1)
          }
        }

    If an invocation of `intercept` completed abruptly with an exception, the resulting message would be something like:

        (Employee's name was Bob Jones) Expected IllegalArgumentException to be thrown, but no exception was thrown

### Inherited from AnyRef

### Inherited from Any